"""
    FactSet Options API

    The Option Prices database provides pricing data such as mid bid-ask price, reference data (e.g., strike price), and risk measures (e.g., Greeks and implied volatility). Visit [Options Overview OA Page # 14925](https://my.apps.factset.com/oa/pages/14925) for details on database coverage. U.S. exchange-traded option bid and ask quotes are continuously updated throughout the day even when no trades have occurred on the option (zero volume). The end-of-day closing bid and ask quotes are always in line with the underlying closing price.  **Note** * Currently in Beta only **OPRA** exchanges are supported.   # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Contact: api@factset.com
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from fds.sdk.FactSetOptions.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
    OpenApiModel
)
from fds.sdk.FactSetOptions.exceptions import ApiAttributeError



class OptionsPrices(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
    }

    validations = {
    }

    @cached_property
    def additional_properties_type():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded
        """
        return (bool, date, datetime, dict, float, int, list, str, none_type,)  # noqa: E501

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        return {
            'ask_time': (float,),  # noqa: E501
            'bid_time': (float,),  # noqa: E501
            'date': (date,),  # noqa: E501
            'fsym_id': (str,),  # noqa: E501
            'price52_week_high': (float,),  # noqa: E501
            'price52_week_low': (float,),  # noqa: E501
            'price_ask': (float,),  # noqa: E501
            'price_bid': (float,),  # noqa: E501
            'price_mid_bid_ask': (float,),  # noqa: E501
            'price_open': (float,),  # noqa: E501
            'price_high': (float,),  # noqa: E501
            'price_low': (float,),  # noqa: E501
            'price_settlement': (float,),  # noqa: E501
            'price_strike': (float,),  # noqa: E501
            'price_underlying': (float,),  # noqa: E501
            'price': (float,),  # noqa: E501
            'quote_type': (str,),  # noqa: E501
            'request_id': (str,),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None


    attribute_map = {
        'ask_time': 'askTime',  # noqa: E501
        'bid_time': 'bidTime',  # noqa: E501
        'date': 'date',  # noqa: E501
        'fsym_id': 'fsymId',  # noqa: E501
        'price52_week_high': 'price52WeekHigh',  # noqa: E501
        'price52_week_low': 'price52WeekLow',  # noqa: E501
        'price_ask': 'priceAsk',  # noqa: E501
        'price_bid': 'priceBid',  # noqa: E501
        'price_mid_bid_ask': 'priceMidBidAsk',  # noqa: E501
        'price_open': 'priceOpen',  # noqa: E501
        'price_high': 'priceHigh',  # noqa: E501
        'price_low': 'priceLow',  # noqa: E501
        'price_settlement': 'priceSettlement',  # noqa: E501
        'price_strike': 'priceStrike',  # noqa: E501
        'price_underlying': 'priceUnderlying',  # noqa: E501
        'price': 'price',  # noqa: E501
        'quote_type': 'quoteType',  # noqa: E501
        'request_id': 'requestId',  # noqa: E501
    }

    read_only_vars = {
    }

    _composed_schemas = {}

    @classmethod
    @convert_js_args_to_python_args
    def _from_openapi_data(cls, *args, **kwargs):  # noqa: E501
        """OptionsPrices - a model defined in OpenAPI

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            ask_time (float): Returns the Bid time. [optional]  # noqa: E501
            bid_time (float): Returns the Last Trade time. [optional]  # noqa: E501
            date (date): The date of data in YYYY-MM-DD format. [optional]  # noqa: E501
            fsym_id (str): FactSet's Option Symbol. For more detail, visit [OA 12636](https://my.apps.factset.com/oa/pages/12636#options). [optional]  # noqa: E501
            price52_week_high (float): 52-Week High Price. [optional]  # noqa: E501
            price52_week_low (float): 52-Week Low Price. [optional]  # noqa: E501
            price_ask (float): Ask price of the option. [optional]  # noqa: E501
            price_bid (float): Bid price of the option. [optional]  # noqa: E501
            price_mid_bid_ask (float): Mid/Bid/Ask price of the option. [optional]  # noqa: E501
            price_open (float): Open price of the option. [optional]  # noqa: E501
            price_high (float): High price of the option. [optional]  # noqa: E501
            price_low (float): Low price of the option. [optional]  # noqa: E501
            price_settlement (float): Settlement price of the option. [optional]  # noqa: E501
            price_strike (float): The stated price per share for which underlying stock may be purchased (for a call) or sold (for a put) by the option holder upon exercise of the option contract.. [optional]  # noqa: E501
            price_underlying (float): The price of the security that must be delivered when a derivative contract, such as a put or call option, is exercised.. [optional]  # noqa: E501
            price (float): The price of the option based on the `quoteType` calculation. For US Options - Returns \"Ask Price\" if calc status==20, otherwise returns \"Mid Bid/Ask Price\". For International Options - Returns \"Settlement Price\". . [optional]  # noqa: E501
            quote_type (str): The calculated quote type, based on the calculated status. This represents the type for `price` field. For US Options - Returns \"Ask Price\" if calc status==20, otherwise returns \"Mid Bid/Ask Price\". For International Options - Returns \"Settlement Price\". . [optional]  # noqa: E501
            request_id (str): The requested identifier submitted in the query.. [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        self = super(OpenApiModel, cls).__new__(cls)

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
        return self

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, *args, **kwargs):  # noqa: E501
        """OptionsPrices - a model defined in OpenAPI

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            ask_time (float): Returns the Bid time. [optional]  # noqa: E501
            bid_time (float): Returns the Last Trade time. [optional]  # noqa: E501
            date (date): The date of data in YYYY-MM-DD format. [optional]  # noqa: E501
            fsym_id (str): FactSet's Option Symbol. For more detail, visit [OA 12636](https://my.apps.factset.com/oa/pages/12636#options). [optional]  # noqa: E501
            price52_week_high (float): 52-Week High Price. [optional]  # noqa: E501
            price52_week_low (float): 52-Week Low Price. [optional]  # noqa: E501
            price_ask (float): Ask price of the option. [optional]  # noqa: E501
            price_bid (float): Bid price of the option. [optional]  # noqa: E501
            price_mid_bid_ask (float): Mid/Bid/Ask price of the option. [optional]  # noqa: E501
            price_open (float): Open price of the option. [optional]  # noqa: E501
            price_high (float): High price of the option. [optional]  # noqa: E501
            price_low (float): Low price of the option. [optional]  # noqa: E501
            price_settlement (float): Settlement price of the option. [optional]  # noqa: E501
            price_strike (float): The stated price per share for which underlying stock may be purchased (for a call) or sold (for a put) by the option holder upon exercise of the option contract.. [optional]  # noqa: E501
            price_underlying (float): The price of the security that must be delivered when a derivative contract, such as a put or call option, is exercised.. [optional]  # noqa: E501
            price (float): The price of the option based on the `quoteType` calculation. For US Options - Returns \"Ask Price\" if calc status==20, otherwise returns \"Mid Bid/Ask Price\". For International Options - Returns \"Settlement Price\". . [optional]  # noqa: E501
            quote_type (str): The calculated quote type, based on the calculated status. This represents the type for `price` field. For US Options - Returns \"Ask Price\" if calc status==20, otherwise returns \"Mid Bid/Ask Price\". For International Options - Returns \"Settlement Price\". . [optional]  # noqa: E501
            request_id (str): The requested identifier submitted in the query.. [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
            if var_name in self.read_only_vars:
                raise ApiAttributeError(f"`{var_name}` is a read-only attribute. Use `from_openapi_data` to instantiate "
                                     f"class with read only attributes.")
